@echo off

rem -----------------------------------------------------------------------------------------------------------
rem
rem SPIN Key and Sef-Signed Certificate Generator
rem
rem Copyright (c) 2002 Harvard Medical School and Massachusetts General Hospital, All Rights Reserved.
rem
rem -----------------------------------------------------------------------------------------------------------

rem
rem Setup Local Configuration
rem

set SERVERNAME=CW-BFITCH.MED.HARVARD.EDU
set INSTITUTION=Harvard
set CITY=Boston
set STATE=MA
set COUNTRY=US
set KEYSTORE=spin.keystore
set PASSWORD=spinkeystore

if "%1" == "" goto help
if %1 == -generate goto generate
if %1 == -import goto import
if %1 == -help goto help


:help
echo usage:
echo.
echo SPINcertificate.bat -generate 
echo   (no parameters needed)
echo. 
echo SPINcertificate.bat -import ^<spin-peer-fqdn^>
echo   e.g. SPINcertificate.bat -import vsl-bwh.partners.org
goto end

:generate
rem
rem Generate the Server Key
rem
keytool -delete -alias %SERVERNAME% -keystore %KEYSTORE% -storepass %PASSWORD%

keytool -genkey -alias %SERVERNAME% -dname "CN=%SERVERNAME%, OU=%INSTITUTION%, O=SPIN Network, L=%CITY%, S=%STATE%, C=%COUNTRY%" -keyalg RSA -keypass %PASSWORD% -storepass %PASSWORD% -keystore %KEYSTORE% -validity 7300

rem 
rem Verify that the Key was stored
rem
keytool -list -v -keystore %KEYSTORE% -storepass %PASSWORD%

rem
rem Export the Key to a Self-Signed Certificate
rem
keytool -export -alias %SERVERNAME% -storepass %PASSWORD% -file %SERVERNAME%.cer -keystore %KEYSTORE%

goto end

:import
rem
rem Import other Servers' certificates
rem
if "%2"=="" goto help   
keytool -delete -alias %2 -keystore %KEYSTORE% -storepass %PASSWORD%

keytool -import -v -trustcacerts -alias %2 -file %2.cer -keystore %KEYSTORE% -keypass %PASSWORD% -storepass %PASSWORD%

rem
rem Verify that Certificate was Imported
rem

echo.
echo ********************************* YOUR KEYSTORE ******************************************
echo.
keytool -list -v -keystore %KEYSTORE% -storepass %PASSWORD%
echo.
echo ********************************* YOUR KEYSTORE ******************************************


goto end


:end 