#!/bin/sh
# -----------------------------------------------------------------------------------------------------------
#
# SPIN Key and Sef-Signed Certificate Generator
#
# Copyright (c) 2002 Harvard Medical School and Massachusetts General Hospital, All Rights Reserved.
#
# -----------------------------------------------------------------------------------------------------------

mode=$1

#
# Setup Local Configuration
#
    SERVERNAME="CW-BFITCH.MED.HARVARD.EDU"
    INSTITUTION="Harvard"
    CITY="Boston"
    STATE="MA"
    COUNTRY="US"
    KEYSTORE="spin.keystore"
    PASSWORD="spinkeystore"

    case "$mode" in
      '-generate')
         # Generate the Server Key
         keytool -delete -alias $SERVERNAME -keystore $KEYSTORE -storepass $PASSWORD

	 keytool -genkey -alias $SERVERNAME -dname "CN=$SERVERNAME, OU=$INSTITUTION, O=SPIN Network, L=$CITY, S=$STATE, C=$COUNTRY" -keyalg RSA -keypass $PASSWORD -storepass $PASSWORD -keystore $KEYSTORE -validity 7300

	 # Verify that the key was stored

	 keytool -list -v -keystore $KEYSTORE -storepass $PASSWORD

	 # Export key to a Self-Signed Certificate

	 keytool -export -alias $SERVERNAME -storepass $PASSWORD -file $SERVERNAME.cer -keystore $KEYSTORE

      ;;

      '-import')
	 # Import other Server's Certificate
         
     keytool -delete -alias $2 -keystore $KEYSTORE -keypass $PASSWORD
      
	 keytool -import -v -trustcacerts -alias $2 -file $2 -keystore $KEYSTORE -keypass $PASSWORD -storepass $PASSWORD

	 # Verify that Certificate was Imported

echo
echo "******************************** YOUR KEYSTORE ***************************"
echo
echo
keytool -list -v -keystore $KEYSTORE -storepass $PASSWORD
echo
echo "******************************** YOUR KEYSTORE ***************************"
echo

      ;;

      *)
	# Usage
        echo "usage:" 
	echo
	echo "SPINCertificate.sh generate"
	echo       "(no parameters needed)"
	echo
	echo "SPINCertificate.sh import <spin-peer-fqdn> "
	echo       "e.g. SPINCertificate.sh -import vsl-bwh.partners.org"
    esac
